#include <iostream>
#include <vector>
#include <string> 
#include <algorithm>
#include <queue>
#include <set>

using namespace std;
typedef long long ll;

const int e9 = 1'000'000'000;
int n, m;
vector<pair<int, int>> dir = { {0, 1}, {1, 0}, {0, -1}, {-1, 0} };

void bfs(pair<int, int> st, const vector<vector<int>>& mp, vector<vector<int>>& ans) {
	int lvl = mp[st.first][st.second];
	if (ans[st.first][st.second] != e9 + 1)
		return;
	ans[st.first][st.second] = lvl;
	queue<pair<int, int>> q;
	q.push(st);
	while (!q.empty()) {
		auto tp = q.front();
		q.pop();
		int x = tp.first;
		int y = tp.second;
		for (auto w : dir) {
			int nx = x + w.first;
			int ny = y + w.second;
			if (nx < 0 || nx >= n || ny < 0 || ny >= m)
				continue;
			if (ans[nx][ny] != e9 + 1)
				continue;
			if (mp[nx][ny] > lvl)
				continue;
			ans[nx][ny] = lvl;
			q.push({ nx, ny });
		}
	}
}

void analize(const vector<vector<int>>& mp, vector<pair<int, pair<int, int>>>& ls) {
	vector<vector<int>> stat(n, vector<int>(m));
	set<pair<int, pair<int, int>>> st;
	for (int i = 0; i < n; i++) {
		stat[i][0] = 1;
		stat[i][m - 1] = 1;
		st.insert({ mp[i][0], {i, 0} });
		st.insert({ mp[i][m - 1], {i, m - 1} });
	}
	for (int j = 1; j < m - 1; j++) {
		stat[0][j] = 1;
		stat[n - 1][j] = 1;
		st.insert({ mp[0][j], {0, j} });
		st.insert({ mp[n - 1][j], {n - 1, j} });
	}

	while (!st.empty()) {
		int lvl = (*st.rbegin()).first;
		queue<pair<int, int>> q;
		q.push((*st.rbegin()).second);
		st.erase(prev(st.end()));
		stat[q.front().first][q.front().second] = 2;
		while (!q.empty()) {
			auto tp = q.front();
			q.pop();
			int x = tp.first;
			int y = tp.second;
			for (auto w : dir) {
				int nx = x + w.first;
				int ny = y + w.second;
				if (nx < 0 || nx >= n || ny < 0 || ny >= m)
					continue;
				if (stat[nx][ny] == 2)
					continue;
				if (mp[nx][ny] <= lvl) {
					if (stat[nx][ny] == 1) {
						st.erase(st.find({ mp[nx][ny], {nx, ny} }));
					}
					stat[nx][ny] = 2;
					q.push({ nx, ny });
				}
				else {
					st.insert({ mp[nx][ny], {nx, ny} });
					ls.push_back({ mp[nx][ny], {nx, ny} });
					stat[nx][ny] = 1;
				}
			}
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;
	vector<vector<int>> mp(n, vector<int>(m));
	vector<vector<int>> ans(n, vector<int>(m, e9 + 1));
	vector<pair<int, pair<int, int>>> q;
	int mx = 0;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++) {
			cin >> mp[i][j];
			if (!i || !j || i == n - 1 || j == m - 1) {
				q.push_back({ mp[i][j], {i, j} });
				mx = max(mx, mp[i][j]);
			}
		}
	analize(mp, q);
	sort(q.begin(), q.end());
	for (auto w : q) 
		bfs(w.second, mp, ans);
	ll res = 0;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			if (ans[i][j] != e9 + 1)
				res += ans[i][j] - mp[i][j];
	cout << res << "\n";
}