#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<int, int>;
const int msz = 1e6 + 5;
const int inf = 1e3 + 5;
const int infv = 1e9 + 5;

vector<pii> g[msz];
int h[inf][inf];
int n, m;

vector<pii> adj(int i, int j){
    vector<pii> out;
    if (i > 1) out.push_back({i - 1, j});
    if (j > 1) out.push_back({i, j - 1});
    if (i < n) out.push_back({i + 1, j});
    if (j < m) out.push_back({i, j + 1});
    return out;
}

int f(int i, int j){
    return m * (i - 1) + j;
}

pii inv(int i){
    int x = (i - 1) / m + 1, y = (i - 1) % m + 1;
    return {x, y};
}

vector<bool> used(msz);
vector<pii> vv;
int mini[inf][inf];

void dfs(int v){
    if (used[v]) return;
    used[v] = true;
    pii f = inv(v);
    vv.push_back(f);
    for (auto [i, t]: g[v]){
        if (used[i]) continue;
        dfs(i);
    }
}

vector<pii> T(int i){
    vector<pii> st;
    for (int j = i; j <= n - i + 1; j++){
        st.push_back({j, i});
        st.push_back({j, m - i + 1});
    }
    for (int j = i; j <= m - i + 1; j++){
        st.push_back({i, j});
        st.push_back({n - i + 1, j});
    }
    return st;
}

bool cmp(pii x, pii y){
    return (h[x.first][x.second] <= h[y.first][y.second]);
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    cin>>n>>m;
    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= m; j++){
            cin>>h[i][j];
        }
    }
    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= m; j++){
            for (auto [u, v]: adj(i, j)){
                g[f(i, j)].push_back({f(u, v), h[u][v]});
            }
        }
    }
    int ans[n + 1][m + 1];
    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= m; j++){
            ans[i][j] = infv;
        }
    }
    for (auto [u, v]: T(1)){
        used[f(u, v)] = true;
        ans[u][v] = h[u][v];
    }
    for (int i = 2; i <= n - i + 1 && i <= m - i + 1; i++){
        vector<pii> st = T(i);
        for (auto [u, v]: st){
            int y = f(u, v);
            mini[u][v] = infv;
            for (auto [j, t]: g[y]){
                if (!used[j]) continue;
                mini[u][v] = min(mini[u][v], t);
            }
        }
        for (auto [u, v]: st){
            if (h[u][v] >= mini[u][v]){
                ans[u][v] = h[u][v];
                used[f(u, v)] = true;
            }
        }
        for (auto [u, v]: st){
            if (used[f(u, v)]) continue;
            vv.clear();
            dfs(f(u, v));
            multiset<int> st;
            for (auto [x, y]: vv){
                st.insert(mini[x][y]);
                for (auto [tt, po]: g[f(x, y)]){
                    int xx = (tt - 1) / m + 1, yy = (tt - 1) % m + 1;
                    if (ans[xx][yy] == infv) continue;
                    st.insert(ans[xx][yy]);
                }
            }
            sort(vv.begin(), vv.end(), cmp);
            while (!vv.empty()){
                auto [x, y] = vv.back();
                if (h[x][y] > *st.begin()){
                    vv.pop_back();
                    for (auto [xx, yy]: g[f(x, y)]){
                        if (ans[xx][yy] == infv) continue;
                        st.erase(st.find(ans[xx][yy]));
                    }
                    ans[x][y] = h[x][y];
                    continue;
                }
                break;
            }
            if (st.empty()) continue;
            int k = *st.begin();
            for (auto [x, y]: vv){
                ans[x][y] = k;
            }
        }
    }
    ll out = 0;
    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= m; j++){
            out += (ans[i][j] - h[i][j]);
        }
    }
    cout<<out;
}